#include "DirectionButtonStatus.h"
#include <SDL3/SDL.h>
#include "NormalizedDirection.h"


bool DirectionButtonStatus::GetDirection(NormalizedDirection & ref_direction)
{
    SDL_Point direction = {0,0};
    if(UpPressed) direction.y -= 1;
    if(DownPressed) direction.y += 1;
    if(LeftPressed) direction.x -= 1;
    if(RightPressed) direction.x += 1;

    float x = (float)direction.x;
    float y = (float)direction.y;
    if((direction.y == 1 || direction.y == -1) 
        && (direction.x == 1 || direction.x == -1))
    {
        x *= c_NormalizedDiagonal;
        y *= c_NormalizedDiagonal;
    }
    ref_direction = NormalizedDirection(x,y,true);
    return UpPressed || DownPressed || LeftPressed || RightPressed;
}